//
// "$Id: $"
//
// Customer. 
//
//                   Copyright (c) 2004, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the names of the copyright holders nor the names of their 
//      contributors may be used to endorse or promote products derived from 
//      this software without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Author : Jean-Marc Lienher (http://www.oksid.ch)
//


#include "Company.h"
#include "Document.h"


Company::Company(Document *d)
{
	parent = d;
}

Company::~Company()
{
}


void Company::print(PrintContext *ctx)
{
	int x, y, i, h;
	PageSetup *stp = parent->pagesetup;
	int ret = 0;

	ctx->x = 0;
	ctx->y = 0;

	if (stp->changed_ != last_changed_pagesetup) {
		int i = 0;
		last_changed_pagesetup = stp->changed_;
		pic_path = stp->get_string("comp_head_pict");
		pic_w = stp->get_int("comp_head_pict_w") * 720 / 254;
		val[i++] = stp->get_string("comp_name");
		val[i++] = stp->get_string("comp_dept");
		val[i++] = stp->get_string("comp_street");
		val[i++] = stp->get_string("comp_post");
		val[i++] = stp->get_string("comp_city");
		val[i++] = stp->get_string("comp_state");
		val[i++] = stp->get_string("comp_country");
		val[i++] = stp->get_string("comp_phone");
		val[i++] = stp->get_string("comp_mobile");
		val[i++] = stp->get_string("comp_fax");
		val[i++] = stp->get_string("comp_email");
		val[i++] = stp->get_string("comp_web");
		val[i++] = stp->get_string("comp_vat");
		nb_val = i;

		stp->get_font("comp_address_font", &afont, &asize, &aunder);
		stp->get_font("comp_city_font", &cfont, &csize, &cunder);
	}
	
	if (ctx->page_num != 1) return;

	fl_color(FL_BLACK);
	fl_font(afont, asize);

	y = 0;
	x = 0;
//	ctx->tk->draw_image(20, 20, im.w()*2, im.h()*2, im.w(), im.h(), im.d(), im.ld(), (const unsigned char *)im.array);

	h = 0;
	y += fl_height() - fl_descent();
	for (i = 0; i < nb_val; i++) {
		int w = 0;
		if (val[i] && val[i][0]) {
			int l = strlen(val[i]);
			if (i == 4) fl_font(cfont, csize);
			w = (int)fl_width(val[i], l);
			ctx->tk->draw(val[i], l, x, y);
			if (fl_height() > h) h = fl_height();
			if (i == 4) {
				fl_font(afont, asize);
				if (cunder == 1) {
					ctx->tk->rectf(x, y + 1, w, csize / 10.0);	
				}
			}
		}
		if ((i == 3 || i == 4) && w > 0) {
			x += w + (int)fl_width(" ");
		} else {
			x = 0;
			y += h;
			h = 0; 
		}
	}

	ctx->y = y;
}



//
// End of "$Id: $".
//

