//
// "$Id: $"
//
// Customer. 
//
//                   Copyright (c) 2004, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Author : Jean-Marc Lienher (http://www.oksid.ch)
//

#ifndef HEADER_H
#define HEADER_H

#include <FL/Fl_Table.H>
#include <FL/fl_draw.H>
#include <FL/Fl_Multiline_Input.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Window.H>
#include "TableInput.h"
#include <sqlite3.h>
#include "Printing.h"

class Header : public Fl_Table {
public:
	int s_left, s_top, s_right, s_bottom;
	int row_edit, col_edit;
	char ***values;
	char *col_names[9];
	TableInput *input;
	int changed_;
	
	int last_changed_pagesetup;
	int print_y;
	Fl_Font hfont;
	Fl_Font tfont;
	Fl_Font nfont;
	int hsize;
	int tsize;
	int nsize;
	int hunder;
	int tunder;
	int nunder;
	const char *about;

	Header(int X, int Y, int W, int H);
	~Header();

	static void event_callback1(Fl_Widget*, void*);
	static void input_callback1(Fl_Widget*, void*);
	void input_callback(void);
	void event_callback(void);
	void draw_cell(TableContext context, int=0, 
		int=0, int=0, int=0, int=0, int=0);
	void init(void);
	void load(void);
	void set(int row);
	void get_value(char *name, char**value, char **type);

	char *get_string(char *name);

	void print(PrintContext *ctx);
};

#endif // HEADER_H

//
// End of "$Id: $".
//

