//
// "$Id: $"
//
// Customer. 
//
//                   Copyright (c) 2004, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Author : Jean-Marc Lienher (http://www.oksid.ch)
//

#ifndef TABLEINPUT_H
#define TABLEINPUT_H

#include <FL/Fl_Table.H>
#include <FL/Fl_Multiline_Input.H>

#define TBLI_TEXT   "a"
#define TBLI_PICT   "b"
#define TBLI_FILE   "c"
#define TBLI_FONT   "d"
#define TBLI_FIND   "e"
#define TBLI_RICH   "f"
#define TBLI_INT    "g"
#define TBLI_DOUBLE "h"
#define TBLI_64_100 "i"
#define TBLI_MONY64 "j"
#define TBLI_COLOR  "k"
#define TBLI_CHOICE "l"
#define TBLI_CHECK  "m"

class TableInputText :public Fl_Multiline_Input {
public:
	TableInputText(int X, int Y, int W, int H);
	int handle(int e);
};

class TableInput : public Fl_Group {
public:
	TableInputText *text_input;
	Fl_Widget *current;
	char type;

	void resize(int X, int Y, int W, int H);
	void value(const char *v);
	const char *value(void);
	void show(const char *type);
	void run_callback(void);
	int handle(int e);
	void draw_selected(int X, int Y, int W, int H, const char *v, const char *t);
	void draw(int X, int Y, int W, int H, const char *v, const char *t);

	TableInput(void);
	void draw(void);

	void get_font(char *value, char *type, Fl_Font *fnt, 
		int *size, int *underline);	
};

#endif // HEADER_H

//
// End of "$Id: $".
//

