//
// "$Id: $"
//
// Application main object. 
//
//                   Copyright (c) 2004, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Author : Jean-Marc Lienher (http://www.oksid.ch)
//

#ifndef THEAPP_H
#define THEAPP_H

#include <FL/Fl_Window.H>
#include <FL/Fl_Output.H>
#include <FL/Fl_Scroll.H>
#include <FL/Fl_Button.H>
#include <FL/Fl_Menu_Bar.H>
#include <FL/Fl_Pixmap.H>
#include "Settings.h"
#include "Document.h"
#include "Printing.h"

class TheApp : public Fl_Window {
public:
	int argc;
	char **argv;

	Settings *settings;
	Fl_Menu_Bar *m_menu;
	Fl_Output *o_status;
	Document *document;
	Printing *printing;


	Fl_Button *b_res;
	Fl_Button *b_open;
	Fl_Button *b_save;
	Fl_Button *b_new;
	Fl_Button *b_print;

	Fl_Pixmap *p_open;
	Fl_Pixmap *p_save;
	Fl_Pixmap *p_new;
	Fl_Pixmap *p_print;

	Fl_Menu_Item *mn_bar;
	Fl_Menu_Item *mn_file;
	Fl_Menu_Item *mn_edit;
	Fl_Menu_Item *mn_tools;
	Fl_Menu_Item *mn_help;

	TheApp(int W, int H);
	~TheApp(void);

	void create_menu(void);
	void save(void);
	void open(void);
	void show(int ac, char **av);
	void print(void);
};

extern TheApp *the_app;


#endif // THEAPP_H

//
// End of "$Id: $".
//

