//
// "$Id: $"
//
// Main entry for Invoice program. 
//
//                   Copyright (c) 2004, O'ksi'D
//                      All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions
// are met:
//
//      Redistributions of source code must retain the above copyright
//      notice, this list of conditions and the following disclaimer.
//
//      Redistributions in binary form must reproduce the above copyright
//      notice, this list of conditions and the following disclaimer in the
//      documentation and/or other materials provided with the distribution.
//
//      Neither the name of O'ksi'D nor the names of its contributors
//      may be used to endorse or promote products derived from this software
//      without specific prior written permission.
//
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
// "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
// LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER
// OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
// EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
// PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// Author : Jean-Marc Lienher (http://www.oksid.ch)
//


#include "TheApp.h"
#include <stdlib.h>
#include <FL/x.H>
#include <FL/Fl.H>



static void exit_cb(Fl_Widget *w, void *data)
{
	delete(the_app); // save settings
	exit(0);
}  

static int my_handler(int event) 
{
	if (event == FL_SHORTCUT) return 1; // eat all shortcut keys
	return 0;
}

int main(int argc, char **argv) 
{
	printf("start\n");
#ifndef WIN32
	fl_open_display();
#endif
	Fl::add_handler(my_handler);
	new TheApp(620, 440);
	the_app->callback(exit_cb);
	the_app->show(argc, argv);
  
	return Fl::run();
}
 
/*
void printd(const char *f, ...)
{
	char buf[512];
	va_list l;
	va_start(l, f);
	//while(va_arg(l, int) != -1) {;}
	_vsnprintf(buf, 512, f, l);
	va_end(l);
	status->value(buf);   
}
*/


//
// End of "$Id: $".
//

