
#include "number.h"
#include "global.h"


i64 arrondi(i64 a)
{
	i64 r, v;
	i64 m = 1;
	if (a < 0) {
		m = -1;
		a = -a;
	}
	v = (a / 10) * 10;
	r = a - v;
	if (r >= 5) v += 10;
	return v * m;
}
 
i64 arrondi5(i64 a)
{
	i64 v;
	i64 m = 1;
	if (a < 0) {
		m = -1;
		a = -a;
	}
	v = a - a % 50;
	return v * m;
}

i64 moins_pc(i64 a, i64 pc)
{
	int m = 1;
	if (a < 0) {
		m = -1;
		a = -a;
	}
	a = a * 100000 / (pc + 100000);
	return arrondi(a * m);
}

i64 plus_pc(i64 a, i64 pc)
{
	i64 m = 1;
	if (a < 0) {
		m = -1;
		a = -a;
	}
	a += a * pc / 100000;
	return arrondi(a * m);
}


char *num_string(i64 a)
{
	char num[] = "0123456789";
	static char buf[256];
	int i = 0, t = 2;
	i64 r, n, d;
	i64 x = 10000000000000;

	a = arrondi(a);
	if (a < 0) {
		buf[i++] = '-';
		a = -a;
	}
	if (a >= x) {
		sprintf(buf, _("Erreur!"));
		return buf;
	}
	n = a;	
	while (x > 100) {
		d = n / x;
		r = d * x;
		x /= 10;
		n -= r; 
		if (a > n) {
			buf[i++] = num[(int)d];
			if (x != 100 && (t % 3) == 0) {
				buf[i++] = '\'';	
			}
		}
		t++;
	}
	if (i == 0 || (i == 1 && buf[0] == '-')) buf[i++] = '0';
	buf[i++] = '.';

	while (x > 1) {
		d = n / x;
		r = d * x;
		x /= 10;
		buf[i++] = num[(int)d];
		n -= r; 
	}
	 
	buf[i] = 0;

	return buf;

}

i64 string_num(const char *c)
{
	i64 a = 0;
	int dot = -1;
	i64 m = 1;

	if (!c) return 0;

	while (*c && dot) {
		if (a == 0 && *c == '-') {
			m = -1;
		} else if (*c >= '0' && *c <= '9') {
			a *= 10;
			a += *c - '0';
			if (dot > 0) dot--;
		} else if (dot < 0 && (*c == ',' || *c == '.')) {
			dot = 3;
		}
		c++;
	}
	if (dot < 0) dot = 3;
	while (dot-- > 0) a *= 10; 
	if (a >= 10000000000000) a = 0;
	return a * m;
}
